﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Futar
{
    class Munka
    {
        public int Nap { get; set; }
        public int Menet { get; set; }
        public int Táv { get; set; }
        public int Menetkód { get; set; }

        public Munka(string[] adat)
        {
            Nap = int.Parse(adat[0]);
            Menet = int.Parse(adat[1]);
            Táv = int.Parse(adat[2]);
            Menetkód = 100 * Nap + Menet;
        }

    }

    class Program
    {
        static List<Munka> munka;
        static void Main(string[] args)
        {
            munka = new List<Munka>();
            #region 1. feladat, beolvasás
            StreamReader sr = new StreamReader("tavok.txt");
            while (!sr.EndOfStream)
            {
                munka.Add(new Munka(sr.ReadLine().Split(' ')));
            }
            sr.Close();
            #endregion

            //rendezés Quick Sorttal, csak mert úgy érdekesebb
            QuickSort(0, munka.Count - 1);

            //rendezés lambda függvénnyel (mert gyakorlatban ezt lehet leggyorsabban megírni és ez rendez leggyorsabban)
            //munka.Sort((m1, m2) => m1.Menetkód.CompareTo(m2.Menetkód));

            #region 2. feladat, első munka
            Console.WriteLine("2. feladat:");
            Console.WriteLine("A hét első munkája {0} km-es volt", munka[0].Táv);
            #endregion

            #region 3. feladat, utolsó munka
            Console.WriteLine("3. feladat:");
            Console.WriteLine("A hét utolsó munkája {0} km-es volt", munka[munka.Count - 1].Táv);
            #endregion

            #region 4. feladat, szabadnapok és 5. 6. feladatok
            Console.WriteLine("4. feladat:");
            Console.Write("Eheti szabadnapok: ");
            int sorszám = 0;
            int[] fuvarszám = new int[8];
            fuvarszám[0] = 0; //max értékű nap
            int[] km = new int[8];
            for (int i = 0; i < 8; i++)
            {
                km[i] = 0;
            }
            for (int i = 1; i < 8; i++)
            {
                fuvarszám[i] = 0;
                while (sorszám < munka.Count && munka[sorszám].Nap == i)
                {
                    fuvarszám[i]++;
                    km[i] += munka[sorszám].Táv;
                    sorszám++;
                }
                if (fuvarszám[i] == 0)
                {
                    Console.Write(i + ". ");
                }
                if (fuvarszám[i] > fuvarszám[fuvarszám[0]])
                {
                    fuvarszám[0] = i;
                }
            }
            Console.WriteLine();
            #endregion

            #region 5. feladat, legtöbb fuvar
            Console.WriteLine("5. feladat:");
            Console.WriteLine("Legtöbb fuvar a(z) {0}. napon volt.", fuvarszám[0]);
            #endregion

            #region 6. feladat, napi km
            Console.WriteLine("6. feladat:");
            for (int i = 1; i < 8; i++)
            {
                Console.WriteLine("{0}. nap: {1} km", i, km[i]);
            }

            #endregion

            #region 7. feladat, egy út díja
            Console.WriteLine("7. feladat:");
            Console.Write("Adja meg a távot: ");
            Console.WriteLine("Az útért kapott díj: {0} Ft", Díj(int.Parse(Console.ReadLine())));
            #endregion

            #region 8. feladat, kiírás és 9. feladat
            Console.WriteLine("8. feladat: kiírás");
            int munkabér = 0;
            using (StreamWriter sw = new StreamWriter("dijazas.txt"))
            {
                foreach (Munka m in munka)
                {
                    sw.WriteLine("{0}. nap {1}. út: {2} Ft", m.Nap, m.Menet, Díj(m.Táv));
                    munkabér += Díj(m.Táv);
                }
            }
            #endregion

            #region 9. feladat, munkabér
            Console.WriteLine("9. feladat");
            Console.WriteLine("Munkadíj: {0}", munkabér);
            #endregion
            Console.ReadLine();
        }

        private static void QuickSort(int e, int v)
        {
            int p = OsztóPont(e, v);
            if (e < p - 1)
            {
                QuickSort(e, p - 1);
            }
            if (p + 1 < v)
            {
                QuickSort(p + 1, v);
            }
        }

        private static int OsztóPont(int e, int v)
        {
            Munka akt;
            akt = munka[e];

            while (e < v)
            {
                while (e < v && munka[v].Menetkód >= akt.Menetkód)
                {
                    v--;
                }
                if (e < v)
                {
                    munka[e] = munka[v];
                    e++;
                }
                while (e < v && munka[e].Menetkód < akt.Menetkód)
                {
                    e++;
                }
                if (e < v)
                {
                    munka[v] = munka[e];
                    v--;
                }

            }
            munka[e] = akt;
            return e;
        }

        private static int Díj(int p)
        {
            int díj = 0;
            if (p < 3)
            {
                díj = 500;
            }
            else if (p < 6)
            {
                díj = 700;
            }
            else if (p < 11)
            {
                díj = 900;
            }
            else if (p < 21)
            {
                díj = 1400;
            }
            else
            {
                díj = 2000;
            }
            return díj;
        }
    }
}
